#ifndef PROB_C
#define PROB_C


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream.h> 
#include <string.h>
#include <ctype.h>

#include "prob_based.h"
#include "../rule/object.h"

#define True 1
#define False 0


int NProblemInlist;
int Length1;
char *List[20];
int option,option1;
int Finish, AutomaticConsultation;
float PriorProbability[NMaxProblems],ProblemProbability[NMaxProblems];
int SymptomsPatient[NMaxSymptoms];
int OrderProblem[NMaxProblems];
int NumberSymptomsPatient;
float SymptomProbability[NMaxSymptoms];
int Finished;
int Explanation;
int FinishedDiagnosis;
int Line;
char d;
FILE *file1;

void ListProblems(void);

/**************Function 1 **********************************************/
static void EraseScreen()
{
  system("clear");
};

/**************Function 2 **********************************************/
static void GenerateList(char *List[20],int *Length1,int ListNumber)
/* 
  used in C

int ListNumber;
char *List[20];
int *Length1;
*/
{
  int j;

  j=ListNumber;
  switch (j)  {
    case 1:
         List[1]="Problems";
         List[2]="Events";
         List[3]="Events of Problems";
         List[4]="Diagnosis";
         List[5]="Save Knowledge base";
         List[6]="Load Knowledge base";
         List[7]="Select explanation";
         List[8]="End";
         *Length1=8;
         break;
   case 2:
         List[1]="Add";
         List[2]="Erase";
         List[3]="List";
         *Length1=3;
         break;
   default:
         break;
   }
}

/**************Function 3**********************************************/
static void OptionList(char *List[20],int Number,int *Option)
/*
  used in C

char *List[20];
int Number;
int *Option;
*/
{
  int i;

  EraseScreen();
  for (i=1; i<=Number; i++)
      printf("  %d   %s \n",i,List[i]);
  printf("\n\n");
  printf("Select one option :");
  do {
     scanf("%d",Option);
     if (((*Option) > Number) || ((*Option) <1))
        printf("\n Invalid option, reenter the option: ");
  } while (((*Option) > Number) || ((*Option) <1));

}

/*********** Function 4*********************************************/
void GiveProblemName(char *Name)
{
  
  char str[NMaxCharactersProblem];

  bzero(str,sizeof(str));
  printf("\nGive name of the Problem(if no more enter quit):");
  scanf("%s",str);
  /* printf("\n Name is %s",Name); */
  /* printf("\n str is %s",str); */
  strncpy(Name,str,strlen(str));
  /* printf("\n Name is %s",Name); */
}

/**********Function 5***********************************************/
/*
  search the number of Problem, if not found, return 0
*/

int SearchProblem(char Name2[NMaxCharactersProblem])
{
  int i,j;

  j=0;
  i=1;
  while ((j == 0) && (i <= NumberofProblems)) {
    /* printf("\n%s, %s",Name2, ProblemName[i]); */
    if ( strcmp(Name2,ProblemName[i]) ==0) {
       j=1;
       break;
       }
    i++;
    }
  /* printf("\n j is %d",j); */
  if (j == 1) 
     return(i);
  else
     return(0);
}
    
       
/*********Function 6***********************************************/
  
void AddProblem(void)
{
  char Name[NMaxCharactersProblem];
  float Probability;
  int times;

  bzero(Name,sizeof(Name));
  GiveProblemName(Name);
  while (strncmp(Name,"quit",4)) {
    if (SearchProblem(Name) == 0) {
       NumberofProblems++;

       /* Before
       do {
          printf("\nGive prior probability");
          scanf("%f",&Probability);
          if ((Probability < 0.0) || (Probability > 1.0)) 
             printf("\n Invalid probability");
          } while (!((Probability >=0.0 ) && (Probability <=1.0)));
       PriorProbability[NumberofProblems]=Probability;
       */

       printf("\n Give happening times of this problem:");
       scanf("%d",&times);
       Problem_Times[NumberofProblems]=times;
       PriorProbability[NumberofProblems]=-1.0; /*have not defined yet*/
       strcpy(ProblemName[NumberofProblems],Name);
       SymptomsProblem[NumberofProblems]=NULL;
       printf("Problem:%s have been defined", Name);
       /* ListProblems(); */
       system("sleep 2");
       }
    else {
       printf("\n The problem already exists");
       }
    bzero(Name,sizeof(Name));
    GiveProblemName(Name);
    }
}
     

/**********Function 7********************************************/

void DisposeSymptomsProblem(int j)
{
  struct ProblemSymptomType *SymptomPtr,*PreviousSymptomPtr;

  SymptomPtr=SymptomsProblem[j];
  SymptomsProblem[j]=NULL;
  while (SymptomPtr != NULL ) {
     PreviousSymptomPtr=SymptomPtr;
     SymptomPtr=SymptomPtr->Next;
     /* C
     free(PreviousSymptomPtr);
     */
     delete PreviousSymptomPtr;
     }
}



/*********Function 8*******************************************/

void EraseProblem(void)
{

  char Name[NMaxCharactersProblem];
  int j;

  bzero(Name,sizeof(Name));
  GiveProblemName(Name);
  while (strncmp(Name,"quit",4)) {
    if ((j=SearchProblem(Name)) != 0) {
       PriorProbability[j]=PriorProbability[NumberofProblems];
       DisposeSymptomsProblem(j);
       ProblemProbability[j]=ProblemProbability[NumberofProblems];
       SymptomsProblem[j]=SymptomsProblem[NumberofProblems];
       strcpy(ProblemName[j],ProblemName[NumberofProblems]);
       NumberofProblems=NumberofProblems-1;
       }
    else
       printf("\n the Problem doesn't exist");

    bzero(Name,sizeof(Name));
    GiveProblemName(Name);
    }
}


/*********Function 9*******************************************/
static void ControlScr()
{
  char s[20];


  Line=Line+1;
  if (Line > NLines) {
     printf("\n----Type character 'c' to cancel and other key to continue:");
     scanf("%s",s);
     d=s[0];
     EraseScreen();
     Line=0;
     }
}


/********Function 10******************************************/
void ListProblems(void)
{

  int i;
  char s[NMaxCharactersProblem];

  EraseScreen();
  printf("\n ******List of Problems**************************************\n");
  printf("**PROB NUM***PROB Times****PriorProbability****ProblemName****\n");
  Line=2;
  d='B';
  i=1;
  while ((i <= NumberofProblems) && (d != 'c'))  {
        printf("   %d           %d           %f,          %s\n",i,Problem_Times[i],PriorProbability[i],ProblemName[i]);
        i++;
        ControlScr();
        }
  if ( d != 'c') {
    printf("\n *****End of List****Hit 'q' <Enter> to exit:");
    scanf("%s",s);
    while ( strcmp(s,"q")) {
      printf("\nHit 'q' <Enter> to exit:");
      scanf("%s",s);
      }
    }
}


/*******Function 11**********************************************/
void GiveSymptomName(char *Name)
{
  char str[NMaxCharactersSymptom];

  bzero(str,sizeof(str));
  printf("\nGive name of the Symptom(if no more enter quit):");
  scanf("%s",str);
  strncpy(Name,str,strlen(str));
}



/********Function 12********************************************/
int GiveSymptomNumber(void)
{

  int i;

  do {
     printf("\nGive number of symptom(if no more give 0)");
     scanf("%d",&i);
     if ((i <0) || (i > NumberofSymptoms)) 
        printf("\n Number out of range(1,%d)",NumberofSymptoms);
     } while ((i <0) || (i > NumberofSymptoms));

  return(i);
}
  

/******Function 13**********************************************/
int SearchSymptom(char Name1[NMaxCharactersSymptom])
{
  int i,j;

  j=0;
  i=1;
  while ((j == 0) && (i <= NumberofSymptoms)) {
    if (! strcmp(Name1,SymptomName[i])) {
       j=1;
       break;
       }
    i++;
    }
  if (j == 1)
     return(i);
  else
     return(0);
}


/******Function 14*********************************************/
void AddSymptom(void)
{
  
  char Name[NMaxCharactersSymptom];

  bzero(Name,sizeof(Name));
  GiveSymptomName(Name);
  while (strncmp(Name,"quit",4)) {
    if (SearchSymptom(Name) == 0) {
       NumberofSymptoms++;
       strcpy(SymptomName[NumberofSymptoms],Name);
       }
    else
       printf("\nThis Symptom already exists");
   
    bzero(Name,sizeof(Name));
    GiveSymptomName(Name);
    }
}

/****Function 15*********************************************/
void ListSymptoms(void)
{

  int i;
  char s[NMaxCharactersSymptom];

  EraseScreen();
  printf("\n ******List of Symptom**********************\n");
  printf("***Sym Num***      ***Sym Name****\n");
  Line=2;
  d='B';
  i=1;
  while ((i <= NumberofSymptoms) && (d != 'c'))  {
        printf("    %d             %s\n",i,SymptomName[i]);
        i++;
        ControlScr();
        }
  if ( d != 'c') {
    printf("\n *****End of List****Hit 'q' <Enter> to exit:");
    scanf("%s",s);
    while ( strcmp(s,"q")) {
      printf("\nHit 'q' <Enter> to exit:");
      scanf("%s",s);
      }
    }
}

/*
  Found-- return 1
  Not Found -- return 0
*/
/*******Function 16***************************************/
int UsedSymptom(int j)
{

  int Found;
  int i;
  struct ProblemSymptomType *SymptomPtr;

  Found=False;
  i=1;
  while ((i <= NumberofProblems) && (Found == False)) {
    SymptomPtr=SymptomsProblem[i];
    while ((SymptomPtr != NULL) && (Found == False)) {
      if (SymptomPtr->Number == j)
         Found=True;
      SymptomPtr=SymptomPtr->Next;
      }
    i++;
    }

  return(Found);
}
 

/****Function 17 ****************************************/ 
void ChangeSymptomNumber(int k,int j)
{
  int i;
  struct ProblemSymptomType *SymptomPtr;

  for (i=1;i<=NumberofProblems;i++) {
      SymptomPtr=SymptomsProblem[i];
      while (SymptomPtr != NULL) {
         if (SymptomPtr->Number == k)
            SymptomPtr->Number=j;
         SymptomPtr=SymptomPtr->Next;
         }
      }
}
 

/**** Function 18 ****************************************/

void EraseSymptom(void)
{
  int i,j;
  char Name[NMaxCharactersSymptom];
  struct ProblemSymptomType *PreviousPtr, *SymptomPtr;
  
  bzero(Name,sizeof(Name));
  GiveSymptomName(Name);
  while (strncmp(Name,"quit",4)) {
     j=SearchSymptom(Name);
     if (j != 0) {
        if (UsedSymptom(j) == 1) {
           printf("\nThis symptom can't be deleted(it appears in disease)");
           }
        else {
           SymptomProbability[j]=SymptomProbability[NumberofSymptoms];
           bzero(SymptomName[j],sizeof(SymptomName[j]));
           strcpy(SymptomName[j],SymptomName[NumberofSymptoms]);
           ChangeSymptomNumber(NumberofSymptoms,j);
           NumberofSymptoms=NumberofSymptoms-1;
           } 
        }
     else
        printf("\n This symptom does not exist");
    
     bzero(Name,sizeof(Name));
     GiveSymptomName(Name); 
     }
}


/*
  return 1-- Found
         0-- Not Found
*/
/****Function 19****************************************/
int SearchSymptomProblem(char Name2[NMaxCharactersSymptom],int Problem)
{
  int Found;
  struct ProblemSymptomType *PreviousPtr,*SymptomPtr;

  Found=False;
  PreviousPtr=NULL;
  SymptomPtr=SymptomsProblem[Problem];
  while ((SymptomPtr != NULL) && (Found == False)) {
    if (! strcmp(Name2,SymptomName[SymptomPtr->Number]))
       Found=True;
    else {
       PreviousPtr=SymptomPtr;
       SymptomPtr=SymptomPtr->Next;
       }
    }
  if (Found)
     return(1);
  else 
     return(0);

}
   

/******Function 20 *************************************/ 
void AddSymptomToProblem(void)
{

  int i,j,k;
  int times;
  char Name1[NMaxCharactersProblem],Name2[NMaxCharactersSymptom];
  float Probability;
  struct  ProblemSymptomType *PreviousPtr, *SymptomPtr;

  bzero(Name1,sizeof(Name1));
  GiveProblemName(Name1);
  while (strncmp(Name1,"quit",4)) {
    i=SearchProblem(Name1);
    /* printf("\n i is %d",i); */
    if (i != 0) {
       j=GiveSymptomNumber(); 
       while (j >0 ) {
         bzero(Name2,sizeof(Name2));
         strcpy(Name2,SymptomName[j]);
         printf("\n Event name is: %s",Name2); 
         k=SearchSymptomProblem(Name2,i);
         if (k == 0) {
            SymptomPtr=new ProblemSymptomType;
            SymptomPtr->Number=j;
            do {
               printf("\nGive times of this event");
               scanf("%d",&times);
               if (times <= Problem_Times[i]) {
                  SymptomPtr->times=times;
                  SymptomPtr->Likehood=(float)times/(float)Problem_Times[i];
                  }
               else
                  printf("\n Invalid times, range must be in(0,%d)", Problem_Times[i]);
               } while ( times > Problem_Times[i]);
            SymptomPtr->Next=SymptomsProblem[i];
            SymptomsProblem[i]=SymptomPtr;
            }
         else 
            printf("\n This symptom is already relevant for this problem");
            
         j=GiveSymptomNumber();
         }
       }
    else
      printf("----This problem does not exist");
    
    bzero(Name1,sizeof(Name1));
    GiveProblemName(Name1);
    }
}


/*********Function 21**************************************************/
void ListSymptomsProblems()
{
  int i;
  struct ProblemSymptomType *SymptomPtr;
  char s[20];
  int num;

  EraseScreen();
  printf("\n       List of Symptoms of Problems           ");
  printf("\n______________________________________________________________");
  printf("\n***Prob Name***    **SYMPTOM(SYM Num, Sym Name, Sym Likehood)**"); 
  Line=2;
  d='B';
  i=1;
  while ((i <= NumberofProblems) && (d != 'c')) {
     printf("\n\n PROB: %s-------SYMPTOM:",ProblemName[i]);
     SymptomPtr=SymptomsProblem[i];
     while (SymptomPtr != NULL) {
        num=SymptomPtr->Number;
        printf("(%d,%s,%f)",num, SymptomName[num],SymptomPtr->Likehood);
        SymptomPtr=SymptomPtr->Next;
        }
     ControlScr();
     i++;
     }

  if ( d != 'c') {
    printf("\n *****End of Rule List****Hit 'q' <Enter> to exit:");
    scanf("%s",s);
    while ( strcmp(s,"q")) {
      printf("\nHit 'q' <Enter> to exit:");
      scanf("%s",s);
      }
    }
}


/*
  Erases a relevant symptom of one problem after checking the existence of the
  problem and that the symptom is relevant for that problem
*/

/************Function 22 **********************************************/

void EraseSymptomProblem(void)
{
  int i,j,k,number1;
  char Name1[NMaxCharactersProblem];
  char Name2[NMaxCharactersSymptom];
  struct ProblemSymptomType *PreviousPtr,*SymptomPtr;
  int Found;

  bzero(Name1,sizeof(Name1));
  GiveProblemName(Name1);
  while (strncmp(Name1,"quit",4)) {
    i=SearchProblem(Name1);
    if (i != 0) {
       j=GiveSymptomNumber();
       while (j > 0) {
          bzero(Name2,sizeof(Name2));
          strcpy(Name2,SymptomName[j]);
          k=SearchSymptomProblem(Name2,i);
          if (k == 1) {
               Found=False;
               PreviousPtr=NULL;
               SymptomPtr=SymptomsProblem[i];
               while ((SymptomPtr != NULL) && (Found == False)) {
                  if (! strcmp(Name2,SymptomName[SymptomPtr->Number]))
                      Found=True;
                  else {
                      PreviousPtr=SymptomPtr;
                      SymptomPtr=SymptomPtr->Next;
                      }
                  }
               
               if (PreviousPtr == NULL) {
                  if (SymptomPtr->Next == NULL)
                     SymptomsProblem[i]=NULL;
                  else
                     SymptomsProblem[i]=SymptomPtr->Next;
                  }
               else
                  PreviousPtr->Next=SymptomPtr->Next;

               /*
               free(SymptomPtr);
               */
               delete SymptomPtr;

               }
          else
             printf("\nThis problem has not this symptom as relevant");
        
          printf("\nSymptom (%s) has been removed from Problem (%s)",SymptomName[j],ProblemName[i]);
          j=GiveSymptomNumber();
          }
       }
    else 
       printf("\n This problem doesn't exist");

    bzero(Name1,sizeof(Name1));
    GiveProblemName(Name1);
    }

}


/**********Function 23*************************************************/ 
/*
  normally, sum s should be 1.0, so NormalizePriorProbability is
  not necessary. 

  The only situation is: one people get two problem at the same time, 
  if we count it as 2 problems, it should have no problem

  Also this prevent user input strange prior probability

  Actually, whether we do Normalize or not, it has no effect to our
  final result

  
*/
 
/*
  second version:

  PriorProbability of each problem change each time of diagnose according to
  Problem_Times of each problem

*/
void NormalizePriorProbability()
{

  int i;
  int s;

  s=0;
  for (i=1;i<=NumberofProblems;i++)
      s=s+Problem_Times[i];
  /* printf("\n Total num of problem happening: %d",s); */
  for (i=1;i<=NumberofProblems;i++)
      PriorProbability[i]=(float)Problem_Times[i]/(float)s;

}


/**********Function 24*********************************************/

void InitializePatientSymptoms(void)
{

  int i;

  for (i=1;i<=NumberofSymptoms;i++)
      SymptomsPatient[i]=0;
}


/**********Function 25*****************************************************/
void CalculateProbabilitySymptoms(void)
{

  int i,j;
  float tmp;
  struct ProblemSymptomType *SymptomPtr;

  for (j=1;j<=NumberofSymptoms;j++)
      SymptomProbability[j]=0.0;

  for (i=1;i<=NumberofProblems;i++) {
      SymptomPtr=SymptomsProblem[i];
      while (SymptomPtr != NULL) {
        j=SymptomPtr->Number;
        tmp=SymptomPtr->Likehood * PriorProbability[i];
        SymptomProbability[j]=SymptomProbability[j]+tmp;
        SymptomPtr=SymptomPtr->Next;
        }
      }
}



void GenerateSymptom(void)
{

}



/**********Function 26*************************************************/

void AskPatientSymptoms(void)
{
 
  int j,k,h;
  int valid;
  int NumberofLinesonScreen;


  NumberofLinesonScreen=10;
  j=1;
  while (j <= NumberofSymptoms) {
    EraseScreen();
    k=j;
    while ((k <= (j+NumberofLinesonScreen-1)) && (k <=NumberofSymptoms)) {
      printf("\n %d: %s",k,SymptomName[k]);
      k++;
      }
    do {
      do {
        valid=False;
        printf("\ngive number of symptom(pos yes,neg no,0 continue,9999 end):");
        scanf("%d",&h);
        if ((abs(h) <= NumberofSymptoms) || (h == 9999)) 
           valid=True;
        if (!valid) 
           printf("\nInvalid number of symptom");
       
        /*
          check if symptom is repeated
        */
        if ((valid && (h != 9999)) && ( h != 0)) 
          if (SymptomsPatient[abs(h)] != 0) {
             valid=False;
             printf("\nThis symptom is already given");
             }
        } while (!valid);         
        if ((h != 0) && (h != 9999)) {
           NumberSymptomsPatient++;
           if (h >0)
              SymptomsPatient[h]=1;
           else
              SymptomsPatient[-h]=-1;
           }
      } while (!((h == 0) ||(h == 9999)));
    if (h == 0) 
       j=j+NumberofLinesonScreen;
    else
       break;
    }
}

/***********Function  27**************************************************/
/*
  calculates probabilityes of all problems conditioned by known symptoms
*/

void CalculateProbabilitiesProblems(void)
{
  int i,j;
  float p,p1;
  float q,s1;
  struct ProblemSymptomType *SymptomPtr;

  s1=0.0;
  for (i=1;i<=NumberofProblems;i++) {
       q=PriorProbability[i];
  /*
       for (j=1;j<=NumberofSymptoms;j++) {
           if (SymptomsPatient[j] !=0) {
              if (SymptomsPatient[j] > 0) 
                 p=SymptomProbability[j];
              else
                 p=1.0-SymptomProbability[j] 
              q=q*p;
              }
           } 
  */
       SymptomPtr=SymptomsProblem[i];
       while (SymptomPtr != NULL) {
          j=SymptomsPatient[SymptomPtr->Number];
          if (abs(j) ==1) {
             if (j ==1) {
                p=SymptomPtr->Likehood;
                p1=SymptomProbability[SymptomPtr->Number];
                }
             else {
                p=1.0-SymptomPtr->Likehood;
                p1=1.0-SymptomProbability[SymptomPtr->Number];
                }
             q=q*p/p1;     
             }
          SymptomPtr=SymptomPtr->Next;
          }

       ProblemProbability[i]=q;
       s1=s1+q;
       }

   for (i=1;i<=NumberofProblems;i++)
       ProblemProbability[i]=ProblemProbability[i]/s1;

}

/********Function 28****************************************************/ 

void OrderProblemsByProbability(void)
{

 int i,m,k,j,c;
 float Max,B;

 for (i=1;i<=NumberofProblems;i++)
     OrderProblem[i]=i;

 for (i=1;i<=NumberofProblems;i++) {
     Max=ProblemProbability[i];
     k=i;
     for (j=i+1;j<=NumberofProblems;j++)
         if (ProblemProbability[j] > Max) {
            Max=ProblemProbability[j];
            k=j;
            }
     B=ProblemProbability[i];
     ProblemProbability[i]=ProblemProbability[k];
     ProblemProbability[k]=B;
     c=OrderProblem[i];
     OrderProblem[i]=OrderProblem[k];
     OrderProblem[k]=c;
     }
}

/******** Function 29 ************************************************/

void ListProblemsByProbability(void)
{

  int i;
  
/*  EraseScreen(); */
  printf("\n\n\n");
  printf("\n***************************************************");
  printf("\n    LIST OF MOST PROBABLE PROBLEMS                 ");
  printf("\n***************************************************");
  for (i=1;i<=NumberofProblems;i++)
      printf("\n%s: %f",ProblemName[OrderProblem[i]],ProblemProbability[i]);
}



/***********Function 30 *****************************************************/

void Diagnosis(void)
{
  int Finish,AutomaticQuestion;
  char Answer[20];

  NumberSymptomsPatient=0;
  NormalizePriorProbability(); 
  InitializePatientSymptoms();  /*Initializes patient`s symptoms to "unknown"*/

  /*Calculates probabilitys of all symptoms assuming disjoint diseases*/
  CalculateProbabilitySymptoms();
  AutomaticConsultation=False;
  AutomaticQuestion=True;

  do {

     if (AutomaticConsultation) 
        GenerateSymptom();
     else
        AskPatientSymptoms();
     
     if (FinishedDiagnosis) 
        printf("\nDiagnosis terminated");
     else {
        CalculateProbabilitiesProblems();
        OrderProblemsByProbability();
        ListProblemsByProbability();
        if (AutomaticQuestion) 
           printf("\nEnd of consultation?(yes,no or automatic):");
        else
           printf("\nEnd of consultation?");
        scanf("%s",Answer);
        if (!(strcmp(Answer,"yes")))
           FinishedDiagnosis=True;
        if (!(strcmp(Answer,"automatic"))) {
           AutomaticConsultation=True;
           AutomaticQuestion=False;
           }
       }
     } while (! (FinishedDiagnosis));
}

void InitializePatientEvents(void)
{
  int i,j;
  ObjectType *ObjPtr;

  for (i=1;i<=NumberofSymptoms;i++)
      SymptomsPatient[i]=0;

    ObjPtr=FirstObject;
    while (ObjPtr != NULL ) {
       if ( (*ObjPtr).Type() == EVENT) {
          if ( ((*ObjPtr).Known() == 1) && (!strcmp( (*ObjPtr).Value(),"T")) ) {
             j=SearchSymptom( (*ObjPtr).Name() );
             SymptomsPatient[j]=1;
             }

          if ( ((*ObjPtr).Known() == 1) && (!strcmp( (*ObjPtr).Value(),"F")) ) {
             j=SearchSymptom( (*ObjPtr).Name() );
             SymptomsPatient[j]=-1;
             }
          }
       ObjPtr=(*ObjPtr).Next();
       };
}



void Diagnosis_START(void)
{
  int Finish,AutomaticQuestion;

/*  NumberSymptomsPatient=0; */
  NormalizePriorProbability();
  InitializePatientEvents();  /*Initializes patient`s symptoms to "unknown"*/

  /*Calculates probabilitys of all symptoms assuming disjoint diseases*/
  CalculateProbabilitySymptoms();

  CalculateProbabilitiesProblems();
  OrderProblemsByProbability();
  ListProblemsByProbability();
}



void SaveInFile(void)
{
  
  int i;
  struct ProblemSymptomType *SymptomPtr;
  char s[40];

/*  printf("\nGive name of the file:");
  scanf("%s",s);
*/
  file1=fopen("PDB.DBF","w");
  
  fprintf(file1,"%d %d\n", NumberofProblems, NumberofSymptoms);
  for (i=1;i<=NumberofProblems;i++)
      fprintf(file1," %s\n",ProblemName[i]);

  for (i=1;i<=NumberofSymptoms;i++)
      fprintf(file1," %s\n",SymptomName[i]);

  for (i=1;i<=NumberofProblems;i++) {
      SymptomPtr=SymptomsProblem[i];
      fprintf(file1," %d",Problem_Times[i]);
      while (SymptomPtr != NULL) {
         fprintf(file1," %d %d",SymptomPtr->Number,SymptomPtr->times);
         SymptomPtr=SymptomPtr->Next;
         }
      fprintf(file1," %d\n",9999);
      }
   fclose(file1);
}

void ReadFromFile(void)
{

  int i,j;
  struct ProblemSymptomType *SymptomPtr, *PreviousPtr;
  char s[40];

/*
  printf("\nGive the name of file:");
  scanf("%s",s);
*/
  file1=fopen("PDB.DBF","r");

  fscanf(file1,"%d %d",&NumberofProblems,&NumberofSymptoms);
  
  for (i=1;i<=NumberofProblems;i++)
      fscanf(file1," %s",ProblemName[i]);

  for (i=1;i<=NumberofSymptoms;i++)
      fscanf(file1," %s",SymptomName[i]);

  for (i=1;i<=NumberofProblems;i++) {
      SymptomsProblem[i]=NULL;
      fscanf(file1," %d",&Problem_Times[i]);
      PriorProbability[i]=-1.0;   /*have not initialize yet*/
      fscanf(file1," %d",&j);
      while (j != 9999) {
          SymptomPtr=new ProblemSymptomType;
          if (SymptomsProblem[i] == NULL) 
             SymptomsProblem[i]=SymptomPtr;
          else
             PreviousPtr->Next=SymptomPtr;
          PreviousPtr=SymptomPtr;
          /* Before 
          fscanf(file1," %f",&SymptomPtr->Likehood);
          */
          fscanf(file1,"%d",&SymptomPtr->times);
          SymptomPtr->Likehood=(float)SymptomPtr->times/(float)Problem_Times[i];
          SymptomPtr->Number=j;
          fscanf(file1," %d",&j);
          }
      PreviousPtr->Next=NULL;
     }
  /*initialize the PriorProbability array*/
  NormalizePriorProbability();
}


void DisposeAll(void)
{

 int i;
 struct ProblemSymptomType *SymptomPtr;

 for (i=1;i<=NumberofProblems;i++) {
     SymptomPtr=SymptomsProblem[i];
     while (SymptomPtr != NULL) {
       SymptomsProblem[i]=SymptomPtr->Next;
       delete SymptomPtr;
       SymptomPtr=SymptomsProblem[i];
       }
     }
}

void PDB()
{
  Explanation=True;
  AutomaticConsultation=False;
  NumberofProblems=0;
  NumberofSymptoms=0;
  Finish=False;
  EraseScreen();
  
  do {
     GenerateList(List,&Length1,1);
     OptionList(List,Length1,&option); /******* Fun 3 *******/
     switch (option) {
       case 1:
             GenerateList(List,&Length1,2);
             OptionList(List,Length1,&option1);
             switch (option1) {
               case 1:
                     AddProblem();
                     break;
               case 2:
                     EraseProblem();
                     break;
               case 3:
                     EraseScreen();
                     ListProblems();
                     break;
               default:
                     break;
               }
             break;
       case 2:
             GenerateList(List,&Length1,2);
             OptionList(List,Length1,&option1);
             switch (option1) {
               case 1:
                     AddSymptom();
                     break;
               case 2:
                     EraseSymptom();
                     break;
               case 3:
                     EraseScreen();
                     ListSymptoms();
                     break;
               default:
                     break;
               }
             break;
       case 3:
             GenerateList(List,&Length1,2);
             OptionList(List,Length1,&option1);
             switch(option1) {
               case 1:
                     AddSymptomToProblem();
                     break;
               case 2:
                     EraseSymptomProblem();
                     break;
               case 3:
                     ListSymptomsProblems();
                     break;
               default:
                     break;
               }
             break;
       case 4:
             FinishedDiagnosis=False;
             Diagnosis();
             break;
       case 5:
             SaveInFile();
             break;
       case 6:
             DisposeAll();
             ReadFromFile();
             break;
       case 7:
             break;
       case 8:
             Finish=True;
             break;
       default:
             break;
       }
  } while (! Finish);

}


#endif   


